<img src="images/purdue-cs-logo.jpg" alt="drawing" width="450"/>

# Reproducing "Neural Packet Routing"

**Members:** [Akram Faqih](https://www.linkedin.com/in/akram-faqih/), [Faisal Vora](https://www.linkedin.com/in/faisaltariqvora/), [Siddharth Dhar](https://www.linkedin.com/in/siddharthdhar16/), [Md Mobasshir Arshed Naved](https://www.linkedin.com/in/md-mobasshir-arshed-7b096841/?originalSubdomain=bd), [Piyush Juneja](https://www.linkedin.com/in/piyushjuneja/), and Bonan Kou

### Problem Statement and Motivation
For this project, we reproduced the paper "Neural Packet Routing." The purpose of this paper is to achieve an optimal, reliable, scalable solution for network packet routing. In the field of IP networking, achieving scalable, reliable, and optimal routing has become a sought-after problem. This means that the researchers are trying to build networks that do not crash, give the best result, and can be used for huge networks. Distributed routing protocols that have become a norm are OSPF/IS-IS. These routing protocols use hop-by-hop packet forwarding. These are good for simplicity, high scalability, and reliability. The problem is that these protocols do not use the resources to their fullest extent, and it is hard to achieve the best solutions using these protocols. The default routing protocols use hop-by-hop routing in which the routing decisions are made at each router independently from other routers. The problem with this is that this only allows us to either achieve optimality or reliability. Hence, we have to use a new routing framework. 

We think that machine learning is a powerful tool. A lot of the previous works and protocols are trying to be redone using machine learning. Neural networks make our life easier and hence we should use them whenever possible. The problem with using neural networks to achieve optimality is that even the best Neural Networks have some errors. This means that our solution will not be reliable. Even a 99% accurate neural network will not work. In the field of networks and routing, errors are not acceptable. The networks must be reliable. To solve the above challenges and solve the problem, the authors of the paper, we reproduced, made a new routing framework called NGR.

### Implementation 
The authors came up with a new routing framework called NGR as a solution. We tried to reproduce the NGR routing framework. NGR is divided into two parts. One part of NGR is the Graph Neural Network module and the other part is the Neural Guided Forwarding Module. Neural Guided Forwarding module is then divided into two more parts- FNN, and SLRR (Sequential Link Reversal Routing) algorithm. We felt that dividing NGR into smaller parts made it easy to divide the work between teammates. It also helped with implementing one part and testing if it works. We first implemented the SLRR algorithm as the pseudo-code was available on the paper. Then we implemented FNN. Implementing GNN took us some time. Lastly, we wrote some benchmarking code to check the convergence for the algorithm for the time metric. We also tested the code for reliability and optimality. We now describe how the NGR framework works. First, we train the GNN module using the data from Internet Topology Zoo [1]. We get feature vectors as a result of running GNN. We use these feature vectors as an input for FNN which gives us the value vector that is then used for the S-LRR algorithm. 

### Challenges
We ran into a lot of difficulties when trying to reproduce this paper. The main issue that we faced was that the paper did not mention which dataset is used. We tried reaching out to the original authors of the paper multiple times to get more information. Knowing which dataset, they used would have helped us to get the exact plot. We did not hear back from the authors of the paper. It just mentioned it used a real network topology from the Internet Topology Zoo [1]. The paper also did not have implementation details. This made it hard to reproduce the exact implementation. We had to make some assumptions and implement the paper based on those assumptions. The right data is crucial for training neural network models. As the exact dataset that they used was missing, we had to train the neural networks on a different dataset. This resulted in us getting different plots than the original paper. Another issue that we had was that none of the team members were familiar with Neural Networks. Some of us had worked with machine learning but no one had experience in NN. This made us run into difficulties making the model. It took us a lot of time to learn neural networks and even after learning some basic concepts it was still difficult to implement it for the FNN and graph neural network required in the paper. The paper used the Tensorflow platform [2] for the neural networks, but we were not able to successfully use it due to the complexity and lack of knowledge about it. We had to switch to PyTorch [3] as one of the members was learning it in another class and was able to implement it. Despite these difficulties, we were still able to achieve reliability, scalability, and optimality in the implemented framework. 

### Results
As mentioned above, we were not aware of the exact implementation details and the dataset that was used for this paper. So, we used our own implementation based on the understanding of the paper. We used data from the Internet Topology Zoo [1] to check the reliability and optimality of the implementation. Each time the SLRR algorithm was able to output a valid path from source to destination. This confirmed the reliability claim by the paper. It also gave the optimal path 100% of the time even though the accuracy was above 90% and lower than 100%. This proved optimality. This shows that we were able to use Neural Networks and overcome the issue of not neural networks having some error. The original paper did not have a benchmark for the time taken to converge on an optimal path. This is the most promising result as this is a metric that the original paper did not check their implementation against. We compared the time it took out an algorithm to converge with the time it took for other routing protocols (OSPF and RIP) to converge. We got the following plot:

<p float="left"><br>
    <img src="images/time_conv.png" width="400"/>
</p>

It is to be noted that this result was from our algorithm with limited knowledge of the original algorithm. We can see that it takes a longer time to converge than OSPF and RIP. This shows that NGR can still be improved. Future research can use the NGR model and try to make it faster. We had a fun time reproducing this paper. Even though we ran into some obstacles, we learned a lot from this experience. 

> Sourcecode: https://github.com/faqihaa/CS536_Final_Project

### References
1. Internet Topology Zoo. http://www.topology-zoo.org/.
2. Tensorflow. https://www.tensorflow.org/.
3. Paszke, A., Gross, S., Chintala, S., Chanan, G., Yang, E., DeVito, Z., Lin, Z., Desmaison, A., Antiga, L., & Lerer, A. (2017). Automatic differentiation in PyTorch.  
